#include <avr/eeprom.h> 
#include <string.h>
#include "hd44780.h"

#define NUM_EXECUTIONS_ADDRESS      0x00
#define ODD_OR_EVEN_ADDRESS         0x02
#define ODD_OR_EVEN_TEXT_ADDRESS    0x03
#define ODD_OR_EVEN_TEXT_LENGTH     5

int main (void)
{
    lcd_init();

	uint16_t num_executions = eeprom_read_word((uint16_t*)NUM_EXECUTIONS_ADDRESS);
	if (num_executions==0xFFFF)
		num_executions=0;
	num_executions++;
	eeprom_write_word((uint16_t*)NUM_EXECUTIONS_ADDRESS,num_executions);

	uint8_t odd_or_even = eeprom_read_byte((uint8_t*)ODD_OR_EVEN_ADDRESS);
	if (odd_or_even==0xFF)
		odd_or_even=num_executions % 2;
	else
		odd_or_even = !odd_or_even;
	eeprom_write_byte((uint8_t*)ODD_OR_EVEN_ADDRESS,odd_or_even);

	char odd_or_even_string[ODD_OR_EVEN_TEXT_LENGTH];
	eeprom_read_block((void*)&odd_or_even_string, (const void*)ODD_OR_EVEN_TEXT_ADDRESS, ODD_OR_EVEN_TEXT_LENGTH);
	char ff_string[5]={0xFF,0xFF,0xFF,0xFF,0xFF};
	if (!strncmp(odd_or_even_string,ff_string,ODD_OR_EVEN_TEXT_LENGTH))
		strcpy(odd_or_even_string,"Odd");
	else if (strcmp(odd_or_even_string,"Even"))
		strcpy(odd_or_even_string,"Even");
	else
		strcpy(odd_or_even_string,"Odd");
	eeprom_write_block ((void*)&odd_or_even_string, (const void*)ODD_OR_EVEN_TEXT_ADDRESS, ODD_OR_EVEN_TEXT_LENGTH);
    
    lcd_clrscr();
	char buffer[16];
	sprintf(buffer,"%d Executions", num_executions);
	lcd_puts(buffer);
	lcd_goto(40);
	sprintf(buffer,"%d %s", odd_or_even, odd_or_even_string);
	lcd_puts(buffer);

    return(0);
}
